#pragma once
#ifndef DATA_FEED_CONNECTION_COUNTER_INCLUDED__
#define DATA_FEED_CONNECTION_COUNTER_INCLUDED__
///////////////////////////////////////////////////////////////////////////////
// File: ConnectionCounter.h
///////////////////////////////////////////////////////////////////////////////
//
// Copyright 2008 JetByte Limited.
//
// This software is provided "as is" without a warranty of any kind. All
// express or implied conditions, representations and warranties, including
// any implied warranty of merchantability, fitness for a particular purpose
// or non-infringement, are hereby excluded. JetByte Limited and its licensors
// shall not be liable for any damages suffered by licensee as a result of
// using the software. In no event will JetByte Limited be liable for any
// lost revenue, profit or data, or for direct, indirect, special,
// consequential, incidental or punitive damages, however caused and regardless
// of the theory of liability, arising out of the use of or inability to use
// software, even if JetByte Limited has been advised of the possibility of
// such damages.
//
///////////////////////////////////////////////////////////////////////////////

#include "JetByteTools/CoreTools/WaitableCounter.h"

///////////////////////////////////////////////////////////////////////////////
// CConnectionCounter
///////////////////////////////////////////////////////////////////////////////

class CConnectionCounter
{
   public :

      explicit CConnectionCounter(
         const long expectedConnections);

      CConnectionCounter(
         const CConnectionCounter &rhs) = delete;

      ~CConnectionCounter();

      CConnectionCounter &operator=(
         const CConnectionCounter &rhs) = delete;

      void ConnectionEstablished();

      void ConnectionFailed();

      void ConnectionComplete();

      HANDLE GetConnectionsCompleteWaitHandle() const;

      HANDLE GetNoConnectionsActiveWaitHandle() const;

      long ConnectionsEstablished() const;

      long ConnectionsFailed() const;

   private :

      JetByteTools::Core::CWaitableCounter m_expectedConnections;

      JetByteTools::Core::CWaitableCounter m_connectionsActive;

      long m_established;

      long m_failed;
};

#endif // DATA_FEED_CONNECTION_COUNTER_INCLUDED__

///////////////////////////////////////////////////////////////////////////////
// End of file: ConnectionCounter.h
///////////////////////////////////////////////////////////////////////////////
