#pragma once
#ifndef COMMAND_LINE_INCLUDED__
#define COMMAND_LINE_INCLUDED__
///////////////////////////////////////////////////////////////////////////////
// File: CommandLine.h
///////////////////////////////////////////////////////////////////////////////
//
// Copyright 2009 JetByte Limited.
//
// This software is provided "as is" without a warranty of any kind. All
// express or implied conditions, representations and warranties, including
// any implied warranty of merchantability, fitness for a particular purpose
// or non-infringement, are hereby excluded. JetByte Limited and its licensors
// shall not be liable for any damages suffered by licensee as a result of
// using the software. In no event will JetByte Limited be liable for any
// lost revenue, profit or data, or for direct, indirect, special,
// consequential, incidental or punitive damages, however caused and regardless
// of the theory of liability, arising out of the use of or inability to use
// software, even if JetByte Limited has been advised of the possibility of
// such damages.
//
///////////////////////////////////////////////////////////////////////////////

#include "ServerCommon/CommandLine.h"

#include "JetByteTools/SocketTools/FlowControlListProcessor.h"

///////////////////////////////////////////////////////////////////////////////
// CCommandLineEx
///////////////////////////////////////////////////////////////////////////////

class CCommandLineEx : public CCommandLine
{
   public :

      CCommandLineEx(
         DWORD argc,
         const char **argv,
         const JetByteTools::Core::_tstring &serverName);

      CCommandLineEx(
         const CCommandLineEx &rhs) = delete;

      CCommandLineEx &operator=(
         const CCommandLineEx &rhs) = delete;

      bool Parse();

      Count MaxBuffersQueued() const;

      Count MaxPendingWrites() const;

      JetByteTools::Socket::CFlowControlListProcessor::ActionOnListFull ActionOnBufferQueueFull() const;

   private :

      void ShowMoreHelp() override;
};

#endif // COMMAND_LINE_INCLUDED__

///////////////////////////////////////////////////////////////////////////////
// End of file: CommandLine.h
///////////////////////////////////////////////////////////////////////////////
