#pragma once
#ifndef ECHO_SERVER_PERFORMANCE_DATA_SCHEMA_INCLUDED__
#define ECHO_SERVER_PERFORMANCE_DATA_SCHEMA_INCLUDED__
///////////////////////////////////////////////////////////////////////////////
// File: PerformanceDataSchema.h
///////////////////////////////////////////////////////////////////////////////
//
// Copyright 2007 JetByte Limited.
//
// This software is provided "as is" without a warranty of any kind. All
// express or implied conditions, representations and warranties, including
// any implied warranty of merchantability, fitness for a particular purpose
// or non-infringement, are hereby excluded. JetByte Limited and its licensors
// shall not be liable for any damages suffered by licensee as a result of
// using the software. In no event will JetByte Limited be liable for any
// lost revenue, profit or data, or for direct, indirect, special,
// consequential, incidental or punitive damages, however caused and regardless
// of the theory of liability, arising out of the use of or inability to use
// software, even if JetByte Limited has been advised of the possibility of
// such damages.
//
///////////////////////////////////////////////////////////////////////////////

#include "JetByteTools/PerfMonTools/PerformanceDataSchema.h"

#include "JetByteTools/CoreTools/tstring.h"

///////////////////////////////////////////////////////////////////////////////
// CPerformanceDataSchema
///////////////////////////////////////////////////////////////////////////////

class CPerformanceDataSchema :
   public JetByteTools::PerfMon::CPerformanceDataSchema
{
   public:

      CPerformanceDataSchema();

      CPerformanceDataSchema(
         const CPerformanceDataSchema &rhs) = delete;

      CPerformanceDataSchema &operator=(
         const CPerformanceDataSchema &rhs) = delete;

      static const JetByteTools::Core::_tstring s_serverExeObjectName;

      static const JetByteTools::Core::_tstring s_serverInstanceObjectName;

      static const JetByteTools::Core::_tstring s_bytesProcessedCounter;

      static const JetByteTools::Core::_tstring s_bytesPerSecondCounter;

      static const JetByteTools::Core::_tstring s_totalBuffersCounter;

      static const JetByteTools::Core::_tstring s_buffersInUseCounter;

      static const JetByteTools::Core::_tstring s_connectionsActiveCounter;

      static const JetByteTools::Core::_tstring s_totalSocketsCounter;

      static const JetByteTools::Core::_tstring s_socketsInUseCounter;

      static const JetByteTools::Core::_tstring s_ioThreadsActiveCounter;

      static const JetByteTools::Core::_tstring s_ioThreadsProcessingCounter;
};

#endif // ECHO_SERVER_PERFORMANCE_DATA_SCHEMA_INCLUDED__

///////////////////////////////////////////////////////////////////////////////
// End of file: PerformanceDataSchema.h
///////////////////////////////////////////////////////////////////////////////
